"{ Encoding: utf8 }" !
"{ Package: 'SpreadSheet:simekf1' }" !

!Integer methodsFor:'general operators'!

addToDate:aDate 
    ^ aDate + self.
! !

!Integer methodsFor:'general operators'!

multiplyString: aString
        | res |
        res := ''.
        self timesRepeat: [res := res , aString ].
        ^ res.
! !

!Number methodsFor:'general operators'!

operatorPlus: arg
        ^ arg addToNumber: self.
! !

!Number methodsFor:'general operators'!

operatorMinus: arg
        ^ arg subtractFromNumber: self.
! !

!Number methodsFor:'general operators'!

operatorTimes: arg
        ^ arg multiplyNumber: self.
! !

!Number methodsFor:'general operators'!

operatorOver: arg
        ^ arg divideNumber: self.
! !

!Number methodsFor:'general operators'!

divideDate: aDate
        ^ nil.
! !

!Number methodsFor:'general operators'!

multiplyDate: aDate
        ^ nil.
! !

!Number methodsFor:'general operators'!

subtractFromDate: aDate
        "FIXME: this could do something else"
        ^ nil.
! !

!Number methodsFor:'general operators'!

subtractFromString: aString
        ^ nil.
! !

!Number methodsFor:'general operators'!

multiplyString: aString
       ^ nil.
! !

!Number methodsFor:'general operators'!

divideString: aString
        ^ nil.
! !

!Number methodsFor:'general operators'!

addToString: aString
        ^ aString , (self asString).
! !

!Number methodsFor:'general operators'!

addToDate:aDate 
    ^ nil.
! !

!Number methodsFor:'general operators'!

operatorNegate
        ^ self negated.
! !

!Number methodsFor:'general operators'!

addToNumber: anInt
        ^ anInt + self.
! !

!Number methodsFor:'general operators'!

divideNumber: anInt
        ^ anInt / self.
! !

!Number methodsFor:'general operators'!

multiplyNumber: anInt
        ^ anInt * self.
! !

!Number methodsFor:'general operators'!

subtractFromNumber: anInt
        ^ anInt - self.
! !

!String methodsFor:'general operators'!

operatorPlus: anOperand
        ^ anOperand addToString: self.
! !

!String methodsFor:'general operators'!

operatorMinus: anOperand
        ^ anOperand subtractFromString: self.
! !

!String methodsFor:'general operators'!

operatorTimes: anOperand
        ^ anOperand multiplyString: self.
! !

!String methodsFor:'general operators'!

operatorOver: anOperand
        ^ anOperand divideString: self.
! !

!String methodsFor:'general operators'!

addToDate: aDate
        ^ nil.
! !

!String methodsFor:'general operators'!

addToString: aString
        ^ aString , self.
! !

!String methodsFor:'general operators'!

divideString: aString
        ^ nil.
! !

!String methodsFor:'general operators'!

divideDate: aDate
        ^ nil.
! !

!String methodsFor:'general operators'!

multiplyDate: aDate
        ^ nil.
! !

!String methodsFor:'general operators'!

multiplyString: aString
        ^ nil.
! !

!String methodsFor:'general operators'!

subtractFromDate: aDate
        ^ nil.
! !

!String methodsFor:'general operators'!

subtractFromString: aString
        ^ nil.
! !

!String methodsFor:'general operators'!

operatorNegate
        ^ nil.
! !

!String methodsFor:'general operators'!

addToNumber: aFloat
        ^ nil.
! !

!String methodsFor:'general operators'!

divideNumber: aFloat
        ^ nil.
! !

!String methodsFor:'general operators'!

multiplyNumber: aFloat
        ^ nil.
! !

!String methodsFor:'general operators'!

subtractFromNumber: aFloat
        ^ nil.
! !

!Object methodsFor:'testing'!

isOperator
    "return true, if the receiver is some kind of an operator
     false is returned here - the method is only redefined in ExprOperator."

    ^ false
! !

!Date methodsFor:'general operators'!

operatorPlus: anOperand
        ^ anOperand addToDate: self.
! !

!Date methodsFor:'general operators'!

operatorMinus: anOperand
        ^ anOperand subtractFromDate: self.
! !

!Date methodsFor:'general operators'!

operatorTimes: anOperand
        ^ anOperand multiplyDate: self.
! !

!Date methodsFor:'general operators'!

operatorOver: anOperand
        ^ anOperand divideDate: self.
! !

!Date methodsFor:'general operators'!

addToDate: aDate
        ^nil.
! !

!Date methodsFor:'general operators'!

addToString: aString
        "FIXME: what format should we use?"
        ^ aString , self year asString , '-' , self month asString , '-' , self day asString.
! !

!Date methodsFor:'general operators'!

divideDate: aDate
        ^nil.
! !

!Date methodsFor:'general operators'!

divideString: aString
        ^ nil.
! !

!Date methodsFor:'general operators'!

multiplyDate: aDate
        ^nil.
! !

!Date methodsFor:'general operators'!

multiplyString: aString
        ^ nil.
! !

!Date methodsFor:'general operators'!

subtractFromDate: aDate
        ^aDate - self.
! !

!Date methodsFor:'general operators'!

subtractFromString: aString
        ^ nil.
! !

!Date methodsFor:'general operators'!

operatorNegate
        ^ nil.
! !

!Date methodsFor:'general operators'!

addToNumber: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

divideNumber: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

multiplyNumber: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

subtractFromNumber: anInt
        ^nil.
! !

