'From Smalltalk/X, Version:5.2.8 on 31-12-2007 at 13:14:33'                     !

"{ Package: 'SpreadSheet:simekf1' }"

Object subclass:#CellExpression
	instanceVariableNames:'root'
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!CellExpression methodsFor:'accessing'!

root
        ^ root.
!

value
        | val |
        root isNil ifTrue: [^ CellEmpty new].
        [val := root value.] on: MessageNotUnderstood do: [:ex | ^ CellUndefined new].
        val isNil ifTrue: [^ CellEmpty new].
        ^val.
! !

!CellExpression methodsFor:'creation'!

root: anExpression
        root := anExpression.
! !

!CellExpression methodsFor:'export'!

exportUsing: anExporter
        ^ anExporter exportExpression: self.
! !

