'From Smalltalk/X, Version:5.2.8 on 31-12-2007 at 13:14:33'                     !

"{ Package: 'SpreadSheet:simekf1' }"

TestCase subclass:#ExpressionTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!ExpressionTests methodsFor:'testing'!

test01
        " just expression tests with no cell references "
        | tree branch |

        " something ordinary "
        " 3 + (2 * 2) "
        branch := ExprBinTimes with: 2 with: 2.
        tree := ExprBinPlus with: 3 with: branch.
        self assert: (tree value = 7).

        " 1.25 * (4 / 2) - (-1) "
        branch := ExprBinOver with: 4 with: 2.
        branch := ExprBinTimes with: 1.25 with: branch.
        tree := ExprBinMinus with: branch with: (ExprUnNegation with: 1).
        self assert: (tree value = 3.5).

        " something weird: "
        " 'foobar' * 2 + Date(0) "
        branch := ExprBinTimes with: 'foobar' with: 2.
        tree := ExprBinPlus with: branch with: (Date fromDays: 0).
        self assert: (tree value = 'foobarfoobar1901-1-1').

        " something meaningless "
        tree := ExprBinTimes with: (Date fromDays: 30) with: (ExprBinPlus with: 1 with: 1.5).
        self assert: (tree value isNil).
!

test02
        " tests with cell references and ranges "
        | tree branch |

        " TODO "
! !

